#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 3e18;


struct rect {
    ll l, r, h, c;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n >> m;

    ll ans = m;

    rect a[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        cin >> a[i].l >> a[i].r >> a[i].h >> a[i].c;
        ans += a[i].h * 2;
    }

    ll pref[n + 1] = {};
    ll prefdiff[n + 1] = {};
    ll prefmult[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i].c; 
        prefdiff[i] = prefdiff[i - 1] + a[i].l - a[i - 1].r;
        prefmult[i] = prefmult[i - 1] + a[i].c * prefdiff[i];
    }


    // -sumof to the left (prefdiff[i] - prefdiff[l]) * c[i]  -sumof to the right (prefdiff[r] - prefdiff[i]) * c[i]  
    // + sumof to the right (prefdiff[l] - prefdiff[j]) * c[i] +sumof to the left (-prefdiff[r] + prefdiff[j]) * c[i]


    // init (prefdiff[r] - prefdiff[i]) * c[i] + (prefdiff[i] - prefdiff[l]) * c[i]
    // = prefdiff[r] * (pref[r] - pref[l - 1]) - (prefmult[r] - prefmult[l]) + (prefmult[r] - prefmult[l])

    ll dp[n + 1] = {};

    for (int r = 1; r <= n; r++) {
        dp[r] = INF;
        for (int l = r; l >= 1; l--) {
            ll here = dp[l - 1] + prefdiff[r] * (pref[r] - pref[l - 1]) - prefdiff[l] * (pref[r] - pref[l - 1]);

            for (int i = l; i < r; i++) {
                here -= min(a[i].h, a[i + 1].h) * 2;
            }

            for (int i = l; i <= r; i++) {
                
                ll save = - (prefmult[i] - prefmult[l - 1]) + prefdiff[l] * (pref[i] - pref[l - 1]) -
                            prefdiff[r] * (pref[r] - pref[i - 1]) + (prefmult[r] - prefmult[i - 1]) +
                            prefdiff[l] * (pref[r] - pref[i]) - prefdiff[i] * (pref[r] - pref[i]) +
                            -prefdiff[r] * (pref[i - 1] - pref[l - 1]) + prefdiff[i] * (pref[i - 1] - pref[l - 1]);
                dp[r] = min(dp[r], here + save);
            }
            
        }
    }

    printf("%lld\n", ans + dp[n]);

    
}
