#include <bits/stdc++.h>
using namespace std;

using ll = long long;


constexpr ll INF = 3e18;


struct rect {
    int l, r, h, c;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n >> m;

    ll ans = m;

    rect a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i].l >> a[i].r >> a[i].h >> a[i].c;
        ans += a[i].h * 2;
    }

    ll pref[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i].c; 
    }

    ll dp[n + 1] = {};

    for (int j = 1; j <= n; j++) {
        
        dp[j] = dp[j - 1];
        for (int i = j + 1; i <= n; i++) {
            ll here = dp[j - 1];
            ll cur = 0;
            for (int k = j; k < i; k++) {
                cur += (pref[i] - pref[k]) * (a[k + 1].l - a[k].r);
                here -= min(a[k + 1].h, a[k].h) * 2;
            }

            ll best = cur;
            for (int k = j; k < i; k++) {
                cur -= (pref[i] - pref[k]) * (a[k + 1].l - a[k].r);
                cur += (pref[k] - pref[j - 1]) * (a[k + 1].l - a[k].r);
                if (cur < best) {
                    best = cur;
                }
            }
            
            if (here + best >= dp[j]) {
                j = i;
                break;
            }
            else {
                dp[j] = here + best;
                if (i == n) {
                    j = n;
                    break;
                }
            }
        }

    }

    printf("%lld\n", ans + *min_element(dp, dp + n + 1));

    
}
