#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int a[1000005], n;
struct seg_tree {
    vector<int> sgt;
    seg_tree(int n) {
        sgt.resize(4 * n);
    }
    void update(int v,int l,int r,int t, int val) {
        if(r < t or l > t) return;
        if(l == r) {
            sgt[v] = val;
            return;
        }
        int m = (l + r) / 2;
        update(v<<1,l,m,t,val);
        update(v<<1|1,m+1,r,t,val);
        sgt[v] = min(sgt[v<<1], sgt[v<<1|1]);
    }
    int first_less(int v,int l,int r,int val) {
        if(sgt[v] >= val) return -1;
        if(l == r) return l;
        int m = (l + r) / 2;
        if(sgt[v<<1] < val) return first_less(v<<1,l,m,val);
        return first_less(v<<1|1,m+1,r,val);
    }
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> a[i];
    seg_tree sgt(n+1);
    vector<pair<pair<int,int>,int>> Q;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        Q.push_back({{r,l},i});
    }
    sort(Q.begin(), Q.end());
    vector<int> ans(q);
    int j = 0;
    for (int i = 0; i < n; i++) {
        sgt.update(1,0,n,a[i],i+1);
        while(j < q and Q[j].first.first == i) {
            ans[Q[j].second] = sgt.first_less(1,0,n,Q[j].first.second+1);
            j++;
        }
    }
    for (int i = 0; i < q; i++) cout << ans[i] << "\n";

}