#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    ll mx = 0;
    vector< pair< pair<ll, ll>, pair<ll, ll> > > v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first.first;
        cin >> v[i].first.second;
        cin >> v[i].second.first;
        cin >> v[i].second.second;
        mx = max(mx, v[i].second.second);
    }
    if (mx == 0) {
        ll ans = m;
        ans += v[0].second.first;
        ans += v[n - 1].second.first;
        for (int i = 0; i < n - 1; i++) {
            ans += abs(v[i].second.first - v[i + 1].second.first);
        }
        cout << ans << '\n';
        return 0;
    }
    vector<ll> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        ll ans = dp[i] + v[i].second.first;
        ll lcoord = v[i].first.first;
        ll tomove = 0;
        ll togo = 0;
        for (int j = i - 1; j >= 0; j--) {
            tomove += (lcoord - v[j].first.second) * v[j].second.second;
            togo += abs(v[j + 1].second.first - v[j].second.first);
            ans = min(ans, dp[j] + tomove + togo + v[j].second.first);
            lcoord -= (v[j].first.second - v[j].first.first);
        }
        // cout << i << ' ' << ans << '\n';
        tomove = 0;
        togo = 0;
        ll rcoord = v[i].first.second;
        dp[i + 1] = min(dp[i + 1], ans + v[i].second.first);
        for (int j = i + 1; j < n; j++) {
            tomove += (v[j].first.first - rcoord) * v[j].second.second;
            togo += abs(v[j - 1].second.first - v[j].second.first);
            dp[j + 1] = min(dp[j + 1], ans + tomove + togo + v[j].second.first);
            rcoord += (v[j].first.second - v[j].first.first);
        }
    }
    cout << dp[n] + m << '\n';
}
