#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
using ll = long long;
const int inf = 2e5 + 5;

struct ST{
    vector<int> t, a;
    int n;
    void build(int v, int tl, int tr){
        if (tl == tr){
            t[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        build(vv, tl, tm);
        build(vv + 1, tm + 1, tr);
        t[v] = min(t[vv], t[vv + 1]);
    }
    ST(vector<int> as){
        a = as;
        n = a.size() - 1;
        t.resize(4 * n);
        build(1, 1, n);
    }
    void upd(int v, int tl, int tr, int& p, int& k){
        if (tl == tr){
            t[v] = k;
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        if (p <= tm){
            upd(vv, tl, tm, p, k);
        }
        else {
            upd(vv + 1, tm + 1, tr, p, k);
        }
        t[v] = min(t[vv], t[vv + 1]);
    }
    void upd(int p, int v){
        upd(1, 1, n, p, v);
    }
    int get(int v, int tl, int tr, int& l, int& r){
        if (l > tr || r < tl) return inf;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2, vv = 2 * v;
        return min(get(vv, tl, tm, l, r), get(vv + 1, tm + 1, tr, l, r));
    }
    int get(int l, int r){
        return get(1, 1, n, l, r);
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n; cin>>n;
    vector<int> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>a[i];
    }
    bool ind1 = true, ind2 = true;
    for (int i = 1; i <= n; i++){
        cin>>b[i];
        if (a[i] != b[i]){
            ind1 = false;
        }
        if (a[i] > 1 || b[i] > 1){
            ind2 = false;
        }
    }
    if (ind1){
        int q; cin>>q;
        vector<pii> end[n + 1];
        for (int i = 1; i <= q; i++){
            int l, r; cin>>l>>r;
            end[r].push_back({l, i});
        }
        vector<int> p(n + 1), out(q + 1), k(2 * n + 2, inf);
        for (int i = 1; i <= n + 1; i++){
            k[i] = i - 1;
            p[i - 1] = i;
        }
        ST T(k);
        for (int i = 1; i <= n; i++){
            T.upd(p[a[i]], inf);
            T.upd(i + n + 1, a[i]);
            p[a[i]] = i + n + 1;
            for (auto [l, j]: end[i]){
                out[j] = T.get(1, n + l);
            }
        }
        for (int i = 1; i <= q; i++){
            cout<<out[i]<<"\n";
        }
        return 0;
    }
    if (ind2){
        int q; cin>>q;
        vector<int> pa[2], pb[2];
        for (int i = 1; i <= n; i++){
            pa[a[i]].push_back(i);
            pb[b[i]].push_back(i);
        }
        vector<int> :: iterator it, it1, it2, it3, it5, it6, it7, it8;
        while (q--){
            int l, r; cin>>l>>r;
            it = lower_bound(pa[0].begin(), pa[0].end(), l);
            it1 = upper_bound(pa[0].begin(), pa[0].end(), r); it1--;
            it2 = lower_bound(pb[0].begin(), pb[0].end(), l);
            it3 = upper_bound(pb[0].begin(), pb[0].end(), r); it3--;
            it5 = lower_bound(pa[1].begin(), pa[1].end(), l);
            it6 = upper_bound(pa[1].begin(), pa[1].end(), r); it6--;
            it7 = lower_bound(pb[1].begin(), pb[1].end(), l);
            it8 = upper_bound(pb[1].begin(), pb[1].end(), r); it8--;
            if ((it == pa[0].end() || *it > r) && (it2 == pb[0].end() || *it2 > r)){
                cout<<0<<"\n";
                continue;
            }
            if (prev(it5) == it6 && prev(it7) == it8){
                cout<<1<<"\n";
                continue;
            }
            bool indx = false, indy = false;
            if (prev(it5) != it6) indx = true;
            if (prev(it7) != it8) indy = true;
            if ((*it6 == *it5) && (*it2 == *it3) && *it2 == *it5){
                indx = true;
            }
            if ((*it8 == *it7) && (*it == *it1) && *it == *it7){
                indy = true;
            }
            if (indx && indy){
                cout<<1<<"\n";
                continue;
            }
            cout<<2<<"\n";
        }
        return 0;
    }
}