#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"

void build(ll v, ll l, ll r, vector<ll> *tree, vector<ll> *elements,
           vector<ll> *elements2) {
  if (r == l) {
    *(tree->begin() + v) = 0;
    ll e = *(tree->begin() + v);
    if (*(elements->begin() + l) == 0) {
      *(tree->begin() + v) = *(tree->begin() + v) + 1;
    }
    if (*(elements2->begin() + l) == 0) {
      *(tree->begin() + v) = *(tree->begin() + v) + 1;
    }
  } else {
    ll a = (l + r) / 2;
    build(v * 2, l, a, tree, elements, elements2);
    build(v * 2 + 1, a + 1, r, tree, elements, elements2);
    *(tree->begin() + v) =
        *(tree->begin() + v * 2) + *(tree->begin() + v * 2 + 1);
  }
}

ll get(ll v, ll l, ll r, ll ql, ll qr, vector<ll> *tree) {
  if (l == r) {
    return *(tree->begin() + v);
  } else {
    ll a = (l + r) / 2;
    ll res = 0;
    if (a >= ql) {
      res += get(v * 2, l, a, ql, qr, tree);
    }
    if (a + 1 <= qr) {
      res += get(v * 2 + 1, a + 1, r, ql, qr, tree);
    }
    return res;
  }
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  //freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, l, r, x, y, mn, mx;
  bool bl1, bl2;
  cin >> n;
  vector<ll> vec_a(n);
  vector<ll> vec_b(n);
  for (ll i = 0; i < n; i++) {
    cin >> vec_a[i];
  }
  for (ll i = 0; i < n; i++) {
    cin >> vec_b[i];
  }
  vector<ll> tree(n * 4);
  build(1, 0, n - 1, &tree, &vec_a, &vec_b);
  cin >> m;
  while (m--) {
    cin >> a >> b;
    a--;
    b--;
    c = get(1, 0, n - 1, a, b, &tree);
    if (c > 0 && c < (b - a + 1) * 2 && b - a > 0) {
      cout << 2;
    } else if (c > 0) {
      cout << 1;
    } else {
      cout << 0;
    }
    cout<<nl;
  }
}
