#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct pereshkoda {
    ll l, r, h, c;
};
struct change {
    ll win, ind1, ind2;
    bool pered;
};

bool comp(change a, change b) {
    return a.win > b.win;
}
bool comp2(pereshkoda a, pereshkoda b) {
    return a.l < b.l;
}

void ans(ll n, vector<change>& win, vector<pereshkoda>& a) {
    for (ll i = 1; i < n; i++) {
        if (a[i - 1].c * (a[i].l - a[i - 1].r) < a[i].c * (a[i].l - a[i - 1].r)) {
            win[i - 1].win = min(a[i - 1].h*2, a[i].h*2) - a[i - 1].c * (a[i].l - a[i - 1].r);
            win[i - 1].ind1 = i - 1;
            win[i - 1].ind2 = i;
            win[i - 1].pered = false;
        }
        else {
            win[i - 1].win = min(a[i - 1].h*2, a[i].h*2) - a[i].c * (a[i].l - a[i - 1].r);
            win[i - 1].ind1 = i - 1;
            win[i - 1].ind2 = i;
            win[i - 1].pered = true;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n, m, time = 0, aind = 0;
    cin >> n >> m;
    vector<pereshkoda> a(n);
    vector<change> win(n-1);
    change maxwin;
    for (ll i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r >> a[i].h >> a[i].c;
    }
    sort(a.begin(), a.end(), comp2);
    while (a.size() > 1) {
        win.clear();
        win.resize(a.size());
        ans(a.size(), win, a);
        maxwin.win = 0;
        for (ll i = 0; i < win.size(); i++) {
            if (win[i].win > maxwin.win) {
                maxwin = win[i];
            }
        }
        if (maxwin.win <= 0) {
            break;
        }
        if (maxwin.pered) {
            time += a[maxwin.ind2].c * (a[maxwin.ind2].l - a[maxwin.ind1].r);
            a[maxwin.ind1].r += a[maxwin.ind2].r - a[maxwin.ind2].l+1;
            a[maxwin.ind1].c += a[maxwin.ind2].c;
            a[maxwin.ind1].h = max(a[maxwin.ind2].h, a[maxwin.ind1].h);
            a.erase(a.begin() + maxwin.ind2);
        }
        else {
            time += a[maxwin.ind1].c * (a[maxwin.ind2].l - a[maxwin.ind1].r);
            a[maxwin.ind2].l -= a[maxwin.ind1].r - a[maxwin.ind1].l+1;
            a[maxwin.ind2].c += a[maxwin.ind1].c;
            a[maxwin.ind2].h = max(a[maxwin.ind2].h, a[maxwin.ind1].h);
            a.erase(a.begin() + maxwin.ind1);
        }
    }
    for (ll i = 1; i <= m; i++) {
        if (i == a[aind].l) {
            time += a[aind].h * 2;
            if (aind+1 < a.size()) {
                aind++;
            }
        }
        time++;
    }
    cout << time << '\n';
}
