#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll MX = 1e16;

struct node {
    int x, v;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin>>n;
    node a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].v;
    }

    ll beg = 0;
    ll end = MX;
    while (beg <= end) {
        ll mid = (beg + end) / 2;
        pair<ll, ll> events[n];
        for (int i = 0; i < n; i++) {
            ll l = a[i].v == 0 ? 1 : max(a[i].x - mid / a[i].v, 1LL);
            ll r = a[i].v == 0 ? n : min(a[i].x + mid / a[i].v, n);
            events[i] = {l, r};
        }
        sort(events, events + n);
        bool ok = true;
        int j = 0;
        priority_queue<ll, vector<ll>, greater<ll>> pq;
        for (int i = 1; i <= n; i++) {
            while (j < n && events[j].first == i) {
                pq.push(events[j].second);
                j++;
            }
            if (pq.empty()) {
                ok = false;
                break;
            }
            pq.pop();
            while (!pq.empty() && pq.top() == i) {
                pq.pop();
            }
            
        }

        if (ok) {
            end = mid - 1;
        }
        else {
            beg = mid + 1;
        }
    }

    printf("%lld\n", end + 1);
}
