#include <bits/stdc++.h>
using namespace std;


struct query {
    int l, r, i, b;

    bool operator<(query& quer) {
        return b < quer.b || b == quer.b && r < quer.r;
    }
};

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("lzcnt,avx2")

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    int a[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    int b[n + 1];
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    int B = sqrt(n);

    int q;
    cin >> q;

    query quer[q];

    for (int i = 0; i < q; i++) {
        cin >> quer[i].l >> quer[i].r;

        quer[i].b = quer[i].l / B;
        quer[i].i = i;
    }

    sort(quer, quer + q);

    int l = quer[0].l, r = quer[0].l - 1;

    priority_queue<int, vector<int>, greater<int>> missing;
    bool isInPq[n + 1] = {};
    for (int i = 0; i <= n; i++) {
        missing.push(i);
        isInPq[i] = true;
    }
    int have[n + 1] = {};
    

    int ans[q];

    for (int i = 0; i < q; i++) {
        if (i != 0 && quer[i].b != quer[i - 1].b) {
            for (int i = 0; i <= n; i++) {
                have[i] = 0;
                if (!isInPq[i]) {
                    missing.push(i);
                }
            }
            l = quer[i].l, r = quer[i].l - 1;
        }
        while (r < quer[i].r) {
            r++;
            have[a[r]]++;
        }
        while (l < quer[i].l) {
            have[a[l]]--;
            if (have[a[l]] == 0) {
                missing.push(a[l]);
                isInPq[a[l]] = true;
            }
            l++;
        }
        while (l > quer[i].l) {
            l--;
            have[a[l]]++;
        }
        while (have[missing.top()] != 0) {
            isInPq[missing.top()] = false;
            missing.pop();
        }
        ans[quer[i].i] = missing.top();
    }

    for (int i = 0; i < q; i++) {
        printf("%i\n", ans[i]);
    }
}
