#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <unordered_map>
#include <queue>
#include <iomanip>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';


struct rect
{
    lli l, r, h, c;
};

vector<rect> v;
vector<pair<lli, lli>> dp;

lli func1(lli ind, lli l)
{
    lli res = dp[l - 1].second;

    lli opt = 0;
    lli p = v[ind].l;
    for (int i = ind-1; i >= l; i--) {
        opt -= v[i].c * (p - v[i].r);
        p = v[i].l;
        opt += min(v[i].h, v[i + 1].h) * 2;
    }
    return res + opt;
}

lli func2(lli r, lli ind)
{
    lli res = dp[ind].first;
    lli opt = 0;
    lli p = v[ind].r;
    for (int i = ind+1; i <=r; i++) {
        opt -= v[i].c * (v[i].l-p);
        p = v[i].r;
        opt += min(v[i].h, v[i - 1].h) * 2;
    }
    return res + opt;

}

void solve()
{
    lli n, m;
    cin >> n >> m;
    v.resize(n + 1);
    lli tans = m;
    for (int i = 1; i <= n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].h >> v[i].c;
        tans += v[i].h * 2;
    }
    dp.resize(n + 1);
    dp[1] = { 0,0};
    for (int i = 2; i <= n; i++) {
        lli l = 1, r = i;
        while (l < r) {
            lli m1 = l + (r - l) / 3;
            lli m2 = r - (r - l) / 3;
            lli val1 = func1(i, m1);
            lli val2 = func1(i, m2);
            if (val1 > val2)r = m2 - 1;
            else l = m1 + 1;
        }
        dp[i].first = func1(i, l);

        l = 1, r = i-1;
        while (l < r) {
            lli m1 = l + (r - l) / 3;
            lli m2 = r - (r - l) / 3;
            lli val1 = func2(i, m1);
            lli val2 = func2(i, m2);
            if (val1 > val2)r = m2 - 1;
            else l = m1 + 1;
        }
        dp[i].second = max(dp[i].first, func2(i, l));
    }
    cout << tans-dp[n].second;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

