#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <unordered_map>
#include <queue>
#include <iomanip>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

struct MyStruct
{
    lli a, b;
};

vector<MyStruct> v;
vector<lli> d;
vector<unordered_map<lli, lli>> dv;

void build(lli a, lli l, lli r)
{
    if (l == r) {
        dv[a][v[l].a]++;
        return;
    }
    lli m = (l + r) / 2;
    build(a * 2 + 1, l, m);
    build(a * 2 + 2, m + 1, r);
    dv[a] = dv[a * 2 + 1];
    for (auto to : dv[a * 2 + 2])dv[a][to.first]++;
}

bool get(lli a, lli tl, lli tr, lli l, lli r, lli val) 
{
    if (tl >= l && tr <= r)return dv[a][val];
    if (tl > r || tr < l)return 0;
    lli tm = (tl + tr) / 2;
    return get(a * 2 + 1, tl, tm, l, r, val) + get(a * 2 + 2, tm + 1, tr, l, r, val);
}

void solve()
{
    lli n;
    cin >> n;
    v.resize(n + 1);
    dv.resize(4 * n);
    for (int i = 1; i <= n; i++)cin >> v[i].a;
    for (int i = 1; i <= n; i++)cin >> v[i].b;
    build(0, 1, n);
    lli q;
    cin >> q;
    for (int k = 1; k <= q; k++) {
        lli l, r;
        cin >> l >> r;
        lli ans = 0;
        while (1) {
            if (get(0, 1, n, l, r, ans)) {
                ans++;
            }
            else {
                cout << ans << LF;
                break;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

