#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
int n;
int t[100001];
int x[100001];
bool solve(ll X) {
    vector<vector<pair<int,int>>> ends(n+1);
    priority_queue<pi,vector<pi>,greater<pi>> pq;
    for(int i = 0;i < n;i++) {
        ll D;
        if(t[i]) D = X/t[i];
        else D = n;
        ends[(int)max(1ll,x[i]-D)].push_back({(int)min((ll)n,x[i]+D),i});
    }
    for(int i = 1;i <= n;i++) {
        for(auto e:ends[i]) {
            pq.push(e);
        }
        if(pq.empty() or pq.top().first < i) {
            return false;
        }
        pq.pop();
    }
    return true;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 0;i < n;i++) {
        cin >> x[i] >> t[i];
    }
    ll l = 0;
    ll r = 1e18;
    while(l < r) {
        ll m = (l+r)/2;
        if(solve(m)) {
            r = m;
        } else {
            l = m+1;
        }
    }
    cout << l << "\n";
}
