#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
const ll inf = 1e14;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n; cin>>n;
    vector<int> x(n + 1), t(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>x[i]>>t[i];
    }
    auto check = [&](ll m){
        vector<int> u(n + 1), v(n + 1), st[n + 1];
        for (int i = 1; i <= n; i++){
            if (t[i]){
                ld dp = 1.0 * m / t[i];
                u[i] = (int) max(1LL, (ll) ceil(x[i] - dp));
                v[i] = (int) min(n * 1LL, (ll) floor(x[i] + dp));
            }
            else {
                u[i] = 1;
                v[i] = n;
            }
            st[u[i]].push_back(v[i]);
        }
        multiset<int> s;
        for (int i = 1; i <= n; i++){
            for (int j: st[i]){
                s.insert(j);
            }
            if (s.empty() || *s.begin() < i){
                return false;
            }
            s.erase(s.begin());
        }
        return true;
    };
    ll l = 0, r = inf;
    while (l + 1 < r){
        ll m = (l + r) / 2; // ans <= m
        if (check(m)){
            r = m;
        }
        else {
            l = m + 1;
        }
    }
    if (check(l)) r = l;
    cout<<r;
}