#include <bits/stdc++.h>
using namespace std;

#define DIMN 200007

int n;
vector<int> a, b;
int tr[4*DIMN];
int res[DIMN];

int get(int v, int l, int r, int L, int R) {
    //cout << v << " " << l << " " << r << " " << tr[v] << endl;
    if (l > R || r < L) return 1e9;

    if (L <= l && r <= R) return tr[v];
    
    int m = (l+r)/2;
    return min(get(2*v+1,l,m,L,R),get(2*v+2,m+1,r,L,R));
}

void upd(int v, int l, int r, int x, int val) {
    if (x > r || x < l) return;

    if (l==r) {
        tr[v] = val;
        return;
    }

    int m = (l+r)/2;
    upd(2*v+1,l,m,x,val);
    upd(2*v+2,m+1,r,x,val);
    tr[v] = min(tr[2*v+1],tr[2*v+2]);
}

int solve(int L, int R) {
    int l = 0, r = n+1;
    //for (int i = 1; i <= n; i++) cout << minpref(i-1); cout << endl;
    while (l < r) {
        
        int m = (l+r)/2;
        //cout << l << " "<< r << " " << m << endl;
        if (get(0,0,n+1,0,m) < L) r = m;
        else l = m+1;
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    /*upd(0,0,15,0,1);
    upd(0,0,15,2,2);
    upd(0,0,15,4,3);
    upd(0,0,15,3,4);
    upd(0,0,15,5,5);
    upd(0,0,15,1,6);
    cout << get(0,0,15,1,2);*/

    //return 0;
    int q;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    cin >> q;
    vector<pair<pair<int,int>,int>> Q(q);
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> Q[i].first.second >> Q[i].first.first;
        Q[i].second = i;
    }
    sort(Q.begin(),Q.end());
    int r = 0, ind = 0;
    //for (int i = 0; i <= n; i++) upd(i,-1);
    while(ind < q) {
        while(ind < q && Q[ind].first.first == r) {
            res[Q[ind].second] = solve(Q[ind].first.second,Q[ind].first.first);
            ind++;
        }
        upd(0,0,n+1,a[r],r+1);
        //cout << a[r] << " " <<r << endl;
        r++;
        //for (int i = 1; i <= n; i++) cout << f[i];
        //cout << endl;
        //for (int i = 1; i <= n; i++) cout << minpref(i-1);
        //cout << endl << endl;
    }
    for (int i = 0; i < q; i++) cout << res[i] << endl;;
}
