#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  //freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, l, r, x, y, mn, mx;
  cin >> n >> m;
  vector<ll> left(n);
  vector<ll> current_left(n);
  vector<ll> size(n);
  vector<ll> height(n);
  vector<ll> cost(n);
  vector<bool> optimized(n, false);
  for (ll i = 0; i < n; i++) {
    cin >> left[i];
    current_left[i] = left[i];
    cin >> d;
    size[i] = d - left[i];
    cin >> height[i];
    cin >> cost[i];
  }
  if (n > 500) {
    ll sm = height[0];
    for (ll i = 1; i < n; i++) {
      if (left[i] == left[i - 1] + size[i - 1] || cost[0] == 0) {
        d = abs(height[i] - height[i - 1]);
      } else {
        d = height[i - 1] + height[i];
      }
      sm += d;
    }
    sm += height[n - 1];
    cout << m + sm;
    return 0;
  }
  ll sm = height[0];
  for (ll i = 1; i < n; i++) {
    mn = (left[i] - (current_left[i - 1] + size[i - 1])) * cost[i];
    ll changing = i;
    ll curr_right = left[i];
    ll distant_cost = 0;
    for (ll j = i - 1; j >= 0; j--) {
      if (!optimized[j])
        break;
      d = cost[j] * (curr_right - (left[j] + size[j]));
      distant_cost += d;
      d = distant_cost;
      curr_right -= size[j];
      if (j != 0) {
        d += min(height[j], height[j - 1]) * 2;
      }
      if (d <= mn) {
        mn = d;
        changing = j;
      }
    }
    if (mn <= height[i] + height[i - 1] - abs(height[i] - height[i - 1])) {
      optimized[i] = true;
      if (changing == i) {
        current_left[i] = current_left[i - 1] + size[i - 1];
      } else {
        if (changing != 0) {
          optimized[changing] = false;
        }
        ll curr_right = left[i];
        for (ll j = i - 1; j >= changing; j--) {
          current_left[j] = curr_right - size[j];
          curr_right -= size[j];
        }
      }
    }
  }
  sm += abs(current_left[0] - left[0]) * cost[0];
  for (ll i = 1; i < n; i++) {
    if (current_left[i] == current_left[i - 1] + size[i - 1] || cost[0] == 0) {
      d = abs(height[i] - height[i - 1]);
    } else {
      d = height[i - 1] + height[i];
    }
    sm += d;
    sm += abs(current_left[i] - left[i]) * cost[i];
  }
  sm += height[n - 1];
  cout << m + sm;
}
